package nl.coffee.math.test;

import nl.coffee.math.*;

public class TestRealNumber
{
   private TestRealNumber()
   {
      System.out.println("Program started");

      System.out.println("Retrieving long values from NumberCentral");
      IntegerNumber three = NumberCentral.valueOf(3);
      IntegerNumber nine = NumberCentral.valueOf(9);

      System.out.println("Performing divide operation");
      RationalNumber oneThird = three.divide(nine);

      System.out.println(""+three+" divided by "+nine+" is: "+oneThird);

      //--------------------------------------

      double someDouble = 0.399;

      System.out.println("Retrieving double value from NumberCentral");
      RationalNumber convertedDouble = NumberCentral.valueOf(someDouble);

      System.out.println(""+someDouble+" converts to "+convertedDouble+
         "(class: "+convertedDouble.getClass().getName()+")");

      someDouble = convertedDouble.doubleValue();

      System.out.println(""+convertedDouble+" converts back to "+someDouble);

      //--------------------------------------


      IntegerNumber n1, n2;

      for (int i=-3; i<=3; i++)
      {
         n1 = NumberCentral.valueOf(i);
         n2 = NumberCentral.valueOf(i);

         if (n1 == n2) {
            System.out.println("number with value "+i+" is shared");
         } else {
            System.out.println("number with value "+i+" is NOT shared");
         }
      }

      //----------------------

      n1 = NumberCentral.valueOf(-25991);
      n2 = NumberCentral.valueOf(-17);
      RationalNumber r = n1.divide(n2);
      IntegerNumber  s = n1.integerDivide(n2);
      IntegerNumber  rem = n1.remainder(n2);
      System.out.println(""+n1+" divided by "+n2+" is "+r);
      System.out.println(""+n1+" divided by "+n2+" is "+s+" remainder: "+rem);

      //----------------------

      n1 = NumberCentral.valueOf(31);
      n2 = NumberCentral.valueOf(8);
      r = n1.divide(n2);
      s = r.trunc();
      RationalNumber z = r.subtract(s);
      System.out.println(""+r+" trunc: "+s+" rest: "+z);

      RationalNumber f1, f2, f3;

      f1 = NumberCentral.valueOf(0.33333333);
      f2 = NumberCentral.valueOf(1).divide(NumberCentral.valueOf(3));
      f3 = f1.subtract(f2);
      System.out.println(""+f1+" - "+f2+" = "+f3);

      //----------------------

      f1 = NumberCentral.valueOf(1.065);
      n1 = NumberCentral.valueOf(18);
long millis = System.currentTimeMillis();
      f2 = f1.pow(n1);
millis = System.currentTimeMillis() - millis;

      System.out.println(""+f1.doubleValue()+"**"+n1+"="+f2+" => "+f2.doubleValue());
      System.out.println("pow operation took "+millis+" millis");
      //----------------------

      long maxLong = Long.MAX_VALUE;
      n1 = NumberCentral.valueOf(maxLong);
      System.out.println("n       == "+n1+": "+n1.getClass().getName());
      IntegerNumber q1 = n1.inc();
      System.out.println("n+1     == "+q1+": "+q1.getClass().getName());
      IntegerNumber q2 = q1.dec();
      System.out.println("(n+1)-1 == "+q2+": "+q2.getClass().getName());

      //---------------------------

      n1 = NumberCentral.valueOf(100);
millis = System.currentTimeMillis();
      n1 = n1.fac();
millis = System.currentTimeMillis() - millis;

      System.out.println("100!="+n1+" in "+millis+" millis");
   }

   public static void main(String[] args)
   {
      new TestRealNumber();
   }

}
