package nl.coffee.math.test;

import nl.coffee.math.*;
import java.math.*;

public class TestSum
{
   public static void main(String[] args)
   {
      new TestSum();
   }

   public TestSum()
   {
      double d1 = 0.3;
      double d2 = 0.6;
      System.out.println("In goes: "+d1+" and "+d2+" == "+(d1+d2));

      RealNumber a = NumberCentral.valueOf(d1);
      RealNumber b = NumberCentral.valueOf(d2);

      System.out.println("This is converted to: "+a+" and "+b);

      d1 = a.doubleValue();
      d2 = b.doubleValue();
      System.out.println("Out goes: "+d1+" and "+d2+" == "+(d1+d2));

      RealNumber c = a.add(b);
      System.out.println("RealNumber.add() gives: "+a.add(b));

      double d3 = c.doubleValue();
      System.out.println("Converted to double: "+d3);

      Sum s = Sum.createInstance(a, b);
      System.out.println("Sum constructed: "+s);

      BigDecimal dec = s.toBigDecimal(1);
      System.out.println("Converted to BigDecimal: "+dec);

      IntegerNumber trunc = s.trunc();
      System.out.println("Truncated: "+trunc);

      d3 = s.doubleValue();
      System.out.println("Converted to double: "+d3);
   }
}
